<template>
  <v-select
    v-model="value"
    :items="roleOptions"
    filled
    dense
    hide-details
    :loading="loading"
    :disabled="isForSelf"
    @change="updateRole"
  />
</template>

<script lang="ts">
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop, Watch } from 'vue-property-decorator'
import { Tutor, UserAccount } from '@/models'
import { changeUserRole } from '@/api'
import { Authentication } from '@/store/modules/authentication'

@Component
export default class RoleSelect extends Vue {
  @Prop({ type: Object, required: true }) readonly tutor!: Tutor

  roleOptions = [UserAccount.RoleEnum.Reviewer, UserAccount.RoleEnum.Tutor]
  value = this.tutor.role
  previousValue = this.value
  loading = false

  get isForSelf() {
    return Authentication.state.user.pk === this.tutor.pk
  }

  async updateRole(newRole: UserAccount.RoleEnum) {
    this.loading = true
    try {
      await changeUserRole(this.tutor.pk, newRole)
      this.previousValue = newRole
    } catch (error) {
      this.value = this.previousValue
    } finally {
      this.loading = false
    }
  }
}
</script>

